#CHAPTER 8: WARNER Appendix
#Installing and attaching packages----
PacMan <- function(pkg){new.pkg <- pkg[!(pkg %in% installed.packages()[, "Package"])] 
if (length(new.pkg))         
  install.packages(new.pkg, dependencies = TRUE)     
sapply(pkg, library, character.only = TRUE)}
pkgs <- c("foreign", "ggplot2", "cowplot", 
          "ez", "car", "multcomp")
PacMan(pkgs)
#
#Set working directory if needed
setwd("C:/Users/.../Desktop/LearningR/IntroToR_vol2")
#
#Import WARNER data----
ANCOVA_DF <- read.spss("Warner/ANCOVAEX.sav", 
                      to.data.frame=TRUE)
names(ANCOVA_DF)
View(ANCOVA_DF)
#
#Checking assumptions----
#Histograms for normality
xcHist <- ggplot(data=ANCOVA_DF, 
       aes(x=xc))+ 
  geom_histogram(position="identity", 
      breaks=seq(3.5, 15.5, 2), col="white")+ 
  theme_classic()
yHist <- ggplot(data=ANCOVA_DF, 
       aes(x=y))+ 
  geom_histogram(position="identity", 
      breaks=seq(4.5, 30, 2.5), col="white")+ 
  theme_classic()
#Plot histograms
plot_grid(xcHist, yHist, 
    labels=c("A", "B"), label_size = 10)
#
#Scatterplot with markers for groups
ggplot(ANCOVA_DF, aes(x=xc, y=y, shape=a)) +
  geom_point(size=2, alpha=.5) +
  theme_classic()
#
#One-way ANOVA----
ANCOVA_DF$ID <- row.names(ANCOVA_DF)
#
ez_xc <- ezANOVA(data=ANCOVA_DF, 
                 dv=xc, wid= ID, 
                 between=a, type=3, 
                 detailed=TRUE, 
                 return_aov=TRUE)
ez_xc$ANOVA
#
ez_y <- ezANOVA(data=ANCOVA_DF, 
          dv=y, wid= ID, 
          between=a, type=3, 
          detailed=TRUE, 
          return_aov=TRUE)
ez_y$ANOVA
ez_y$`Levene's Test for Homogeneity of Variance`
#
#ANCOVA----
#ANCOVA with interaction
ANCOVA_y_Int <- aov(y~a*xc, data=ANCOVA_DF)
Anova(ANCOVA_y_Int, type=3)
#
#ANCOVA without interaction
ANCOVA3_y <- aov(y~xc+a, data=ANCOVA_DF)
summary.aov(ANCOVA3_y)
summary(glht(ANCOVA3_y, 
       linfct=mcp(a="Tukey")))
Contrasts <- rbind(c(1, 0, -1), 
                   c(0, 1, -1))
row.names(Contrasts) <- c("Self-Paced vs Lecture", 
                          "Seminar vs Lecture")
summary(glht(ANCOVA3_y, 
      linfct=mcp(a=Contrasts)))