#CHAPTER 13: WARNER Appendix
#Install and attach packages----
PacMan <- function(pkg){new.pkg <- pkg[!(pkg %in% installed.packages()[, "Package"])] 
if (length(new.pkg))         
  install.packages(new.pkg, dependencies = TRUE)     
sapply(pkg, library, character.only = TRUE)}
pkgs <- c("foreign", "psych")
PacMan(pkgs)
#
#Set working directory if needed
setwd("C:/Users/.../Desktop/LearningR/IntroToR_vol2")
#
#Import WARNER temperature data----
Temp_DF <- na.omit(read.spss(
    "Warner/reliabilityexample1.sav", 
    to.data.frame=TRUE))
names(Temp_DF)
View(Temp_DF)
#
#Time 1 and Time 2 correlation
cor.test(Temp_DF$fahrenheit1, 
          Temp_DF$fahrenheit2)
#
#Import WARNER depression data----
Dep_DF <- read.spss(
    "Warner/depressionitems.sav", 
    to.data.frame=TRUE)
names(Dep_DF)
View(Dep_DF)
#
#Principal Axis Factoring----
PAF <- fa(Dep_DF[,2:6], nfactors=1, 
          fm="pa", rotate="none")
#Communalities
IntComm <- round(smc(Dep_DF[,2:6]),3)
ExtComm <- round(PAF$communality,3)
CommDF <- data.frame(IntComm,ExtComm)
#View communalities
View(CommDF)
#
PAF$e.values
#
PAF$Vaccounted
#
PAF$loadings
#
round(PAF$weights, 3)
#
#Convert scores to match normal coding
min(Dep_DF$dep1)
max(Dep_DF$dep1)
#
Dep_DF$dep1 <- Dep_DF$dep1-1
Dep_DF$dep2 <- Dep_DF$dep2-1
Dep_DF$dep3 <- Dep_DF$dep3-1
Dep_DF$revdep4 <- Dep_DF$revdep4-1
Dep_DF$dep5 <- Dep_DF$dep5
View(Dep_DF[,2:6])
#
#Reverse Code Dep Item 4
min(Dep_DF$revdep4, na.rm=TRUE)
max(Dep_DF$revdep4, na.rm=TRUE)
Dep_DF$dep4 <- 3-Dep_DF$revdep4
names(Dep_DF)
View(Dep_DF[,c(5,22)])
#
#Create scale scores
key <- list(dep=c("dep1", "dep2", "dep3", "-revdep4","dep5"))
DepScale <- scoreItems(
  keys = key, 
  items = Dep_DF, 
  totals = TRUE, missing = TRUE,
  impute = "mean",
  min = 0, max = 3)
Dep_DF$DepScale <- DepScale$scores
View(Dep_DF[,c(2,3,4,5,6,22,25)])
DepScale$alpha
#
#Scale without item 5
key2 <- list(dep=c("dep1", "dep2", "dep3", "-revdep4"))
DepScale2 <- scoreItems(
  keys = key2, 
  items = Dep_DF, 
  totals = TRUE, missing = TRUE,
  impute = "mean",
  min = 0, max = 3)
DepScale2$alpha
DepScale2$item.corrected
 