#CHAPTER 13: Reliability and Validity
#Install and attach packages----
PacMan <- function(pkg){new.pkg <- pkg[!(pkg %in% installed.packages()[, "Package"])] 
if (length(new.pkg))         
  install.packages(new.pkg, dependencies = TRUE)     
sapply(pkg, library, character.only = TRUE)}
pkgs <- c("psych")
PacMan(pkgs)
#
#Set working directory if needed
setwd("C:/Users/.../Desktop/LearningR/IntroToR_vol2")
#
#Import EFA Items data----
Happy_DF <- read.csv("HappyData.csv", 
        header=TRUE, 
        na.strings=c("NA", " ", ""))
#
#Test-Retest: Correlation T1 and T2
cor.test(Happy_DF$HappyT1, 
         Happy_DF$HappyT2)
#
#Principal Axis Factoring----
PAF <- fa(Happy_DF[,2:5], nfactors=1, 
          fm="pa", rotate="none")
#Communalities
IntComm <- round(smc(Happy_DF[,2:5]),3)
ExtComm <- round(PAF$communality,3)
CommDF <- data.frame(IntComm,ExtComm)
#View communalities
View(CommDF)
#
PAF$e.values
#
PAF$Vaccounted
#
PAF$loadings
#
#Internal Reliability and Scale scores----
#Create key and scale
key <- list(Happy=c("Happ_1", "Happ_2", "Happ_3", "-Happ_4_REV"))
HappyScale <- scoreItems(
  keys = key, 
  items = Happy_DF, 
  totals = TRUE, missing = FALSE)
#Save scale scores to data frame
Happy_DF$HappyScale <- HappyScale$scores
View(Happy_DF[,c(7,10)])
#Reliability measures
HappyScale$alpha
HappyScale$item.corrected
#
#Reverse Code Happy Item 4----
HappMin <- min(Happy_DF$Happ_4_REV, na.rm=TRUE)
HappMax <- max(Happy_DF$Happ_4_REV, na.rm=TRUE)
Happy_DF$Happ_4 <- ((HappMax+HappMin)-Happy_DF$Happ_4_REV)
names(Happy_DF)
View(Happy_DF[,c(5,6,9)])