#CHAPTER 16: WARNER Appendix
#Install and attach packages----
PacMan <- function(pkg){new.pkg <- pkg[!(pkg %in% installed.packages()[, "Package"])] 
if (length(new.pkg))         
  install.packages(new.pkg, dependencies = TRUE)     
sapply(pkg, library, character.only = TRUE)}
pkgs <- c("foreign", "lmtest", "aod")
PacMan(pkgs)
#
#Set working directory if needed
setwd("C:/Users/.../Desktop/LearningR/IntroToR_vol2")
#
#Import WARNER dog data----
Dog_DF <- read.spss("Warner/dog.sav", 
  to.data.frame=TRUE)
names(Dog_DF)
View(Dog_DF)
#
table(Dog_DF$death, Dog_DF$dogown)
#Reformat dogown variable levels
Dog_DF$dogown2 <- factor(Dog_DF$dogown, 
                         levels=c("dog", "no dog"))
table(Dog_DF$death, Dog_DF$dogown)
table(Dog_DF$death, Dog_DF$dogown2)
#Binary Log 
DogMod <- glm(death~dogown2, data=Dog_DF, family="binomial")
#
#Test overall model----
anova(DogMod, test="Chisq")
lrtest(DogMod)
##Coefficients----
DogMod$coefficients
#Test Coefficient
wald.test(b=coef(DogMod), Sigma=vcov(DogMod), Terms=1)
wald.test(b=coef(DogMod), Sigma=vcov(DogMod), Terms=2)
#
##Odds of Death----
#Owners compared to non-owners
exp(coef(DogMod))
#Non-owners compared to owners
1/exp(coef(DogMod))
#
#Estimated Probability of Death
Dog_DF$PredDeath <- predict(DogMod, type="response")
View(Dog_DF)
#
#Example 2----
#Import mice survival data
Mice_DF <- read.spss("Warner/ld50.sav", 
               to.data.frame=TRUE)
View(Mice_DF)
names(Mice_DF)
#
#Reformat gender variable
Mice_DF$gender2<-factor(Mice_DF$gender, 
    levels=c("female", "male"))
MiceMod <- glm(death ~ drugdose + gender2, 
               data=Mice_DF, family="binomial")
#
#Test overall model
lrtest(MiceMod)
##Coefficients----
MiceMod$coefficients
#Test - Drug Dose Coef
wald.test(b=coef(MiceMod),
    Sigma=vcov(MiceMod), Terms=2)
#Test - Gender coef
wald.test(b=coef(MiceMod),
    Sigma=vcov(MiceMod), Terms=3)
#
##Odds of Death----
exp(coef(MiceMod))
#
#Predicted value
Examp_DF <- data.frame(drugdose=c(0:10, 0:10), 
                       gender2=c(rep("female",11),rep("male",11)))
Examp_DF$PredDeath <- predict(MiceMod, Examp_DF, type="response")
View(Examp_DF)
#Visualize predicted value
ggplot(Examp_DF, aes(x=drugdose, y=PredDeath, fill=gender2)) +
  geom_bar(stat="identity", position="dodge")
